//: c15:JabberServer.java

import java.io.*;
import java.net.*;

public class JabberServer {  

  public static final int PORT = 8085;
  public static void main(String[] args) throws IOException {
    ServerSocket s = new ServerSocket(PORT);
    System.out.println("Started: " + s);
    try {
      Socket socket = s.accept();  // blocked!
      try {
        System.out.println("Connection accepted: "+ socket);
        
        BufferedReader in = 
          new BufferedReader(
            new InputStreamReader(
              socket.getInputStream()));
        
        PrintWriter out = 
          new PrintWriter(
            new BufferedWriter(
              new OutputStreamWriter(
                socket.getOutputStream())),true);  // flush
        
        while (true) {  
          String str = in.readLine();
          if (str.equals("END")) break;
          str = "Echoing: " + str;
          System.out.println(str);
          out.println("\n"+str);
        }
      
      } finally {
	        System.out.println("closing Socket");
	        socket.close();
      }
    } finally {
	      System.out.println("closing ServerSocket");
	      s.close();
    }
  } 
} ///:~
